states[S_BS_CHILL] = {SPR_BIOS, A, -1, nil, 0, 0, S_BS_CHILL}
states[S_BS_SLASH] = {SPR_BIOS, A, 88, nil, 0, 0, S_BS_CHILL}

mobjinfo[MT_SLASHER] = {
	--$Title Dumb Idiot Unnamed Green Biograft
	--$Sprite BIOSA0
	--$Category PHLIGHT
	doomednum = 2301,
	spawnstate = S_BS_CHILL,
	spawnhealth = 1,
	seestate = S_BS_CHILL,
	reactiontime = 32,
	painchance = 0,
	deathstate = S_XPLD1,
	deathsound = sfx_pop,
	speed = 30,
	radius = 29*FRACUNIT,
	height = 76*FRACUNIT,
	flags = MF_ENEMY|MF_SPECIAL|MF_SHOOTABLE
}

addHook("MobjSpawn", function(mobj)
	mobj.movetics = 0
	mobj.wantx = 0
	mobj.wanty = 0
	mobj.cd = 0
end, MT_SLASHER)

--this guy uses random number generator to do stuff
addHook("MobjThinker", function(mobj)
	if mobj.state == S_BS_CHILL then
		mobj.cd = $ - 1
		if mobj.movetics == 0 then
			mobj.movetics = P_RandomRange(40, 150)
			mobj.wantx = P_RandomRange(-5, 5)
			mobj.wanty = P_RandomRange(-5, 5)
		else
			mobj.movetics = $ - 1
			if mobj.movetics > 20
				if P_TryMove(mobj, mobj.x+(mobj.wantx*FRACUNIT), mobj.y+(mobj.wanty*FRACUNIT), false) == false
					mobj.movetics = 13
				end
			end
		end
		if P_LookForPlayers(mobj, FRACUNIT*300, true, false) == true and mobj.cd <= 0 then
			mobj.state = S_BS_SLASH
			mobj.cd = 126
			mobj.movetics = 0
			S_StartSound(mobj, sfx_slash)
		end
	end
	if mobj.state == S_BS_SLASH then
		if mobj.tics == 24
			P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_AOESLASH)
		end
	end
end, MT_SLASHER)