--btw set mobjscale of those things to 1.5!!

states[S_BNCLIGHT_BASIC] = {SPR_BNCL, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_BNCLIGHT_BASIC}
states[S_BNCLIGHT_DO] = {SPR_BNCL, FF_FULLBRIGHT|B, 34, nil, 0, 0, S_BNCLIGHT_BASIC}

mobjinfo[MT_BOUNCELANTERN] = {
	--$Title Bounce Lantern
	--$Sprite BNCLA0
	--$Category PHLIGHT
	doomednum = 2306,
	spawnstate = S_BNCLIGHT_BASIC,
	spawnhealth = 999,
	reactiontime = 0,
	painchance = 0,
	speed = 4,
	radius = 23*FRACUNIT,
	height = 52*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

local function heya(person, tablesbroken)
	for i = 1, #tablesbroken do
		if tablesbroken[i] == person then return false end 
	end
	return true
end

addHook("MobjSpawn", function(light)
	light.usedby = {}
	light.coolfloor = light.z
	light.momz = FU
end, MT_BOUNCELANTERN)

addHook("MobjThinker", function(light)
	if light.z <= light.coolfloor then --copypaste from egglauncher cuz its cool as heck
		light.momz = min(FU, $+FU/30)
	else
		light.momz = max(-FU, $-FU/30)
	end
	for i = 1, #light.usedby do
		if light.usedby[i] == nil or light.usedby[i].valid == false then return end
		if P_IsObjectOnGround(light.usedby[i]) then table.remove(light.usedby, i) break end
	end
end, MT_BOUNCELANTERN)

addHook("TouchSpecial", function(light, pmo)
	if light == nil or light.valid == false
	or pmo == nil or pmo.valid == false then return true end
	
	if light.state == S_BNCLIGHT_BASIC and heya(pmo, light.usedby) then
		light.state = S_BNCLIGHT_DO
		pmo.momz = max(24*FU, min(96*FU, -pmo.momz))
		table.insert(light.usedby, pmo)
		S_StartSound(light, sfx_kc4c)
	end
	return true
end, MT_BOUNCELANTERN)