local function PH_DefaultStats(dude)
	if not (dude and dude.valid) then return end
	dude.mo.ph_clientfile = nil
	--io file variables above lol
	dude.mo.ph_progress = 0 --1 is player near the booth 2 is player activated the menu
	dude.mo.ph_buttonhold = false
	--decor stuff
	dude.mo.ph_buttonfocus = 0
	dude.mo.ph_circle = 5
	--funny кнопка
	dude.mo.ph_fun = 1
	dude.mo.ph_funtime = 0
	--menu navigation
	dude.mo.ph_menupart = 0
	dude.mo.ph_menusubpart = 0
	dude.mo.ph_menusublimit = 1
	--store movement variables here
	dude.mo.ph_forwardmove = 0
	dude.mo.ph_sidemove = 0
	--camera stuff
	dude.mo.ph_keeper = nil
	dude.mo.ph_camera = nil
	dude.mo.ph_zoomtime = 0
	--easing stuff
	dude.mo.ph_menufocus = 0
	dude.mo.ph_menufocus2 = 0 --180
		
	--CLIENT OPTIONS (these, are strings (dear god))
	dude.ph_sonicslam = 0
	dude.ph_debugprint = 0
	
	--apply already existing settings
	dude.mo.ph_clientfile = io.openlocal("client/PHLIGHT/ph_client.cfg")
	if dude.mo.ph_clientfile then
		local numberofhorns = dude.mo.ph_clientfile:read("*a")
		COM_BufInsertText(dude, numberofhorns)
		dude.mo.ph_clientfile:close()
	end
end

--find booth keeper, if there is any nearby.
local function PH_FindBoothKeeper(p)
	if not searchBlockmap("objects", function(refmobj, foundmobj)
		if foundmobj.type == MT_BOOTHGUY then p.mo.ph_keeper = foundmobj return true end
	end, p.mo, p.mo.x-192*FU, p.mo.x+192*FU, p.mo.y-192*FU, p.mo.y+192*FU) then
		return true
	end
end

PH.ActivateMenu = function(p)
	p.mo.ph_progress = 2
	p.mo.ph_menupart = 1
	p.mo.ph_buttonfocus = 0
	P_PlayJingleMusic(p, "TRAFFIC", 0, true, JT_OTHER)
	
	if PH_FindBoothKeeper(p) then
		p.mo.ph_camera = P_SpawnMobjFromMobj(p.mo.ph_keeper, 0,0,32*FU, MT_BOOTHCAM)
		p.awayviewmobj = p.mo.ph_camera
		p.mo.ph_zoomtime = 1
	end
end

--check if there are any nils in variables
--return true if there are no nils
local function legaldrinkingage(arg1, arg2)
	if arg1 == nil then return false end
	if arg2 == nil then return false end
	return true
end

PH.DisableMenu = function(p)
	p.mo.ph_progress = 0
	p.mo.ph_keeper = nil
	p.mo.ph_zoomtime = 0
	p.mo.ph_funtime = 0
	p.mo.ph_clientfile = io.openlocal("client/PHLIGHT/ph_client.cfg", "w+")
	if legaldrinkingage(p.ph_sonicslam, p.ph_debugprint) then
		p.mo.ph_clientfile:write("ph_numberofhorns "..p.ph_sonicslam.." "..p.ph_debugprint)
		p.mo.ph_clientfile:flush()
		PH.DebugPrint("Number of horns was successfly saved! "..p.ph_sonicslam.." "..p.ph_debugprint)
	end
	p.mo.ph_clientfile:close()
	p.mo.ph_clientfile = io.openlocal("client/PHLIGHT/ph_client.cfg")
	if p.mo.ph_clientfile then
		local numberofhorns = p.mo.ph_clientfile:read("*a")
		COM_BufInsertText(p, numberofhorns)
		p.mo.ph_clientfile:close()
	end
	if p.mo.ph_camera == nil then return end
	if p.mo.ph_camera.valid == true then P_RemoveMobj(p.mo.ph_camera) end
end

--visual setting
local function PH_ONorOFF(arg)
	if arg == "1" then return "ON"
	else return "OFF" end
end

--apply settings from IO file
COM_AddCommand("ph_numberofhorns", function(p, arg1, arg2)
	p.ph_sonicslam = arg1
	p.ph_debugprint = arg2
	PH.DebugPrint("Number of horns was successfly loaded! "..arg1.." "..arg2)
end, COM_LOCAL)

--open PHIGHTING! [ALPHA] menu
COM_AddCommand("ph_menu", function(p)
	if G_IsSpecialStage() then
		print("\x82HOW DARE YOU!!\x80 Why would you ever use A PHIGHTING! [ALPHA] MENU in a SPECIAL STAGE?! Unless if you change, don't talk to my loyalness ever again!!")
		return
	elseif p.mo.ph_progress == 2 then 
		print("Since PHIGHTING! [ALPHA] menu is already open, we will close it now lol.")
		PH.DisableMenu(p)
		P_RestoreMusic(p)
		return
	end
	PH.ActivateMenu(p)
end, COM_LOCAL)

--get forwardmove and sidemove before they get hit by Hyperlaser F
addHook("PreThinkFrame", function()
	for p in players.iterate do
		if p == nil or p.valid == false or p.mo == nil or p.mo.valid == false then return end
		if p.mo.ph_forwardmove == nil then return end
		p.mo.ph_forwardmove = p.cmd.forwardmove
		p.mo.ph_sidemove = p.cmd.sidemove
	end
end)

addHook("PlayerSpawn", PH_DefaultStats)

addHook("PlayerThink", function(p)
	if p == nil or p.valid == false or p.mo == nil or p.mo.valid == false then return end
	if p.bot then return end
	if p.mo.ph_circle == nil then PH_DefaultStats(p) end
	--disable menu if dead
	if p.playerstate == PST_DEAD and p.mo.ph_progress == 2 then
		PH.DisableMenu(p)
		if p.lives > 0 then
			P_RestoreMusic(p)
		end
	end
	
	p.mo.ph_circle = $+1
	
	if p.mo.ph_funtime > 0 then p.mo.ph_funtime = $+1 end
	if p.mo.ph_funtime == 29 then p.mo.ph_funtime = 0 end
	
	if p.mo.ph_circle >= 12*5 then p.mo.ph_circle = 5 end --this variable should never go above 60 or below 5
	
	--easing variable here cuz stupid hud hook doesnt lets me to change it
	--btw this happens near the booth
	if (p.mo.ph_progress == 1 and P_IsObjectOnGround(p.mo) and p.speed == 0) or p.mo.ph_progress == 2 then
		p.mo.ph_menufocus = min(FU, $+FU/40)
	else
		p.mo.ph_menufocus = max(0, $-FU/40)	
	end
	
	--Main Chunk
	if p.mo.ph_progress > 0 then
		if P_IsObjectOnGround(p.mo) and p.speed == 0 then p.pflags = $|PF_JUMPSTASIS end
		if p.cmd.buttons & BT_ATTACK then
			p.mo.ph_buttonhold = true
		end
		--jump button section
		if p.cmd.buttons & BT_JUMP then
			if p.mo.ph_progress == 1 and P_IsObjectOnGround(p.mo) and p.mo.ph_buttonhold == false and p.speed == 0 then
				PH.ActivateMenu(p)
			--menu funny button
			elseif p.mo.ph_progress == 2 and p.mo.ph_menupart == 1 and p.mo.ph_buttonhold == false then
				S_StartSound(nil, sfx_phunbt, p)
				p.mo.ph_fun = P_RandomRange(1, 14)
				p.mo.ph_funtime = 1
				
			--open up a category
			elseif p.mo.ph_progress == 2 and p.mo.ph_menusubpart == 0 and p.mo.ph_buttonhold == false then
				
				if p.mo.ph_menupart == 2 then p.mo.ph_menusublimit = 1
				elseif p.mo.ph_menupart == 3 then p.mo.ph_menusublimit = 2
				end
				
				p.mo.ph_menusubpart = 1
			end
			p.mo.ph_buttonhold = true
		end
		
		--Camera shifting
		if p.mo.ph_zoomtime >= 1 then
			p.awayviewtics = 2
			p.awayviewaiming = ANG340
			if p.mo.ph_zoomtime > 36 then p.mo.ph_zoomtime = 36 end
			if p.mo.ph_zoomtime == 1 then
				p.mo.ph_camera.angle = p.mo.ph_keeper.angle-ANGLE_225
				P_InstaThrust(p.mo.ph_camera, p.mo.ph_camera.angle, -8*FU)
			elseif p.mo.ph_zoomtime == 36 then
				p.mo.ph_camera.momx = 0
				p.mo.ph_camera.momy = 0
				p.mo.ph_camera.momz = 0
			else
				P_SetObjectMomZ(p.mo.ph_camera, 3*FU, false)
				P_InstaThrust(p.mo.ph_camera, p.mo.ph_camera.angle, -8*FU)
			end
			p.mo.ph_zoomtime = $+1
		end
		
		--Move UP or DOWN
		if p.mo.ph_forwardmove > 25 and p.mo.ph_progress == 2 and p.mo.ph_menusubpart ~= 0 and p.mo.ph_buttonhold == false then
			PH.DebugPrint("story o")
			if p.mo.ph_menusubpart == 1 then
				p.mo.ph_menusubpart = p.mo.ph_menusublimit
			else
				p.mo.ph_menusubpart = $-1
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonhold = true
		elseif p.mo.ph_forwardmove > 25 and p.mo.ph_progress == 2 and p.mo.ph_menusubpart == 0 and p.mo.ph_buttonhold == false then
			PH.DebugPrint("deez")
			if p.mo.ph_menupart == 1 then
				p.mo.ph_menupart = 3
			else
				p.mo.ph_menupart = $-1
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonfocus = 0
			p.mo.ph_buttonhold = true
		end
		if p.mo.ph_forwardmove < -25 and p.mo.ph_progress == 2 and p.mo.ph_menusubpart ~= 0 and p.mo.ph_buttonhold == false then
			PH.DebugPrint("f undertale")
			if p.mo.ph_menusubpart == p.mo.ph_menusublimit then
				p.mo.ph_menusubpart = 1
			else
				p.mo.ph_menusubpart = $+1
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonhold = true
		elseif p.mo.ph_forwardmove < -25 and p.mo.ph_progress == 2 and p.mo.ph_buttonhold == false then
			PH.DebugPrint("nuts")
			if p.mo.ph_menupart == 3 then
				p.mo.ph_menupart = 1
			else
				p.mo.ph_menupart = $+1
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonfocus = 0
			p.mo.ph_buttonhold = true
		end
		
		--move LEFT or RIGHT
		if p.mo.ph_sidemove < -25 and p.mo.ph_progress == 2 and p.mo.ph_menusubpart ~= 0 and p.mo.ph_buttonhold == false then
			if p.mo.ph_menupart == 3 and p.mo.ph_menusubpart == 1 
				if p.ph_sonicslam == "1" then p.ph_sonicslam = "0"
				else p.ph_sonicslam = "1" end
			elseif p.mo.ph_menupart == 3 and p.mo.ph_menusubpart == 2
				if p.ph_debugprint == "1" then p.ph_debugprint = "0"
				else p.ph_debugprint = "1" end
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonhold = true
		end
		if p.mo.ph_sidemove > 25 and p.mo.ph_progress == 2 and p.mo.ph_menusubpart ~= 0 and p.mo.ph_buttonhold == false then
			if p.mo.ph_menupart == 3 and p.mo.ph_menusubpart == 1 
				if p.ph_sonicslam == "1" then p.ph_sonicslam = "0"
				else p.ph_sonicslam = "1" end
			elseif p.mo.ph_menupart == 3 and p.mo.ph_menusubpart == 2
				if p.ph_debugprint == "1" then p.ph_debugprint = "0"
				else p.ph_debugprint = "1" end
			end
			S_StartSound(nil, sfx_btnchc, p)
			p.mo.ph_buttonhold = true
		end
		
		--spin button section
		if p.cmd.buttons & BT_SPIN then
			if p.mo.ph_progress == 2 and p.mo.ph_menusubpart == 0 and p.mo.ph_buttonhold == false then
				PH.DisableMenu(p)
				P_RestoreMusic(p)
			elseif p.mo.ph_progress == 2 and p.mo.ph_menusubpart ~= 0 and p.mo.ph_buttonhold == false then
				p.mo.ph_menusubpart = 0
			end
			p.mo.ph_buttonhold = true
		end
		--to restore ability to press buttons
		if not (p.cmd.buttons & BT_SPIN) and not (p.cmd.buttons & BT_JUMP)
		and p.mo.ph_forwardmove == 0 and p.mo.ph_sidemove == 0 then
			p.mo.ph_buttonhold = false
		end
		--animation of the button becoming bigger
		if p.mo.ph_buttonfocus == 14
			p.mo.ph_buttonfocus = 14
		else
			p.mo.ph_buttonfocus = $+1
		end
		if p.mo.ph_progress == 2 then
			p.mo.ph_menufocus2 = min(FU, $+FU/40)
			p.pflags = $|PF_STASIS
			return	
		end
	end
	p.mo.ph_menufocus2 = max(0, $-FU/40) --if not progress == 2
	p.mo.ph_menupart = 0
	p.mo.ph_progress = 0
end)

addHook("LinedefExecute", function(line, pmo)
	if pmo == nil or pmo.valid == false then return end
	if pmo.ph_progress <= 1 then
		pmo.ph_progress = 1
	end
end, "PH_MENU")

hud.add(function(v, p)
	--main part
	--local hhhhhh, scalex = v.dupx()
	--local llllll, scaley = v.dupy()
	if p.mo == nil or p.mo.valid == false then return end
	if p.bot then return end
	local mo = p.mo
	local mfocus = mo.ph_menufocus
	local mfocus2 = mo.ph_menufocus2
	
	if v.width() == 1366 then
		hudinfo[HUD_SCORE].x = ease.inoutsine(mfocus2, 16, 16-180)
		hudinfo[HUD_SCORENUM].x = ease.inoutsine(mfocus2, 120, 120-180)
	else
		hudinfo[HUD_SCORE].x = ease.inoutsine(mo.ph_menufocus, 16, 16-180)
		hudinfo[HUD_SCORENUM].x = ease.inoutsine(mo.ph_menufocus, 120, 120-180)
	end
	hudinfo[HUD_TIME].x = ease.inoutsine(mfocus2, 16, 16-180)
	hudinfo[HUD_MINUTES].x = ease.inoutsine(mfocus2, 72, 72-180)
	hudinfo[HUD_TIMECOLON].x = ease.inoutsine(mfocus2, 72, 72-180)
	hudinfo[HUD_SECONDS].x = ease.inoutsine(mfocus2, 96, 96-180)
	hudinfo[HUD_TIMETICCOLON].x = ease.inoutsine(mfocus2, 96, 96-180)
	hudinfo[HUD_TICS].x = ease.inoutsine(mfocus2, 120, 120-180)
	hudinfo[HUD_RINGS].x = ease.inoutsine(mfocus2, 16, 16-180)
	hudinfo[HUD_RINGSNUM].x = ease.inoutsine(mfocus2, 96, 96-180)
	hudinfo[HUD_RINGSNUMTICS].x = ease.inoutsine(mfocus2, 120, 120-180)
	hudinfo[HUD_LIVES].x = ease.inoutsine(mfocus2, 16, 16-180)
	
	if mo.ph_progress == 2 then
	
		if p.cmd.buttons & BT_ATTACK then
			v.drawString(30, 40, "MOVE UP - MOVE UP")
			v.drawString(30, 60, "MOVE DOWN - MOVE DOWN")
			v.drawString(30, 80, "MOVE RIGHT - CHANGE TO THE RIGHT PAGE/OPTION", 0, "small")
			v.drawString(30, 100, "MOVE LEFT - CHANGE TO THE LEFT PAGE/OPTION", 0, "small")
			v.drawString(30, 120, "JUMP - CONFIRM")
			v.drawString(30, 140, "SPIN - BACK")
			return
		end
		
		v.drawScaled(0, ease.inoutsine(mfocus2, 180*FU, 0), FU/2, v.cachePatch("PH_MEN1"), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		v.drawStretched(0, ease.inoutsine(mfocus2, 180*FU, 0), FU*8, FU/2, v.cachePatch("PH_MEN2"), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		v.drawScaled(ease.inoutsine(mfocus2, 180*FU, 0), 0, FU/2, v.cachePatch("PH_MEN3"), V_SNAPTOTOP|V_SNAPTORIGHT)
		v.drawScaled(ease.inoutsine(mfocus2, 400*FU, 569*FU/2), 16*FU, FU/2, v.cachePatch("PH_CRC"..(mo.ph_circle/5)), V_SNAPTOTOP|V_SNAPTORIGHT)
		
		if mo.ph_menusubpart == 0 then
			--buttons
			for i = 1, 3 do
				if mo.ph_menupart == i then
					v.drawScaled(72*FU-(mo.ph_buttonfocus*FU/2), (i*36)*FU-(14*FU)-(mo.ph_buttonfocus*FU/8), (FU/2)+(mo.ph_buttonfocus*320), v.cachePatch("PH_BTN"..i), V_SNAPTOTOP|V_SNAPTORIGHT)
				else
					v.drawScaled(72*FU, (i*36)*FU-(14*FU), FU/2, v.cachePatch("PH_BTN"..i), V_SNAPTOTOP|V_SNAPTORIGHT)
				end
			end
			
			if p.mo.ph_menupart == 1
				v.drawString(6*FU, ease.inoutsine(mfocus2, (189+180)*FU, 189*FU), "I don' think this does anything but it's silly.", V_ORANGEMAP|V_ALLOWLOWERCASE, "small-fixed")
			elseif p.mo.ph_menupart == 2
				v.drawString(6*FU, ease.inoutsine(mfocus2, (189+180)*FU, 189*FU), "Need sum advice to deal with those kids?", V_ORANGEMAP|V_ALLOWLOWERCASE, "small-fixed")
			elseif p.mo.ph_menupart == 3
				v.drawString(6*FU, ease.inoutsine(mfocus2, (189+180)*FU, 189*FU), "Mind tellin' me about yourself?", V_ORANGEMAP|V_ALLOWLOWERCASE, "small-fixed")
			end
		elseif p.mo.ph_menupart == 2
			v.drawString(160, 90, "W.I.P.", 0, "center")
		elseif p.mo.ph_menupart == 3
			v.drawString(160, 96, "Sonic Slam Ability - "..PH_ONorOFF(p.ph_sonicslam), 0, "small-center")
			v.drawString(160, 111, "Debug Print - "..PH_ONorOFF(p.ph_debugprint), 0, "small-center")
		end
		
		if p.mo.ph_funtime > 0 then
			v.draw(0, 0, v.cachePatch("PH_FUN"..p.mo.ph_fun), FU*(p.mo.ph_funtime/3))
		end
		
		return
	elseif mfocus2 > 0
		v.drawScaled(0, ease.inoutsine(mfocus2, 180*FU, 0), FU/2, v.cachePatch("PH_MEN1"), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		v.drawStretched(0, ease.inoutsine(mfocus2, 180*FU, 0), FU*8, FU/2, v.cachePatch("PH_MEN2"), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		v.drawScaled(ease.inoutsine(mfocus2, 180*FU, 0), 0, FU/2, v.cachePatch("PH_MEN3"), V_SNAPTOTOP|V_SNAPTORIGHT)
		v.drawScaled(ease.inoutsine(mfocus2, 400*FU, 569*FU/2), 16*FU, FU/2, v.cachePatch("PH_CRC"..(p.mo.ph_circle/5)), V_SNAPTOTOP|V_SNAPTORIGHT)
	end
	if p.mo.ph_progress == 1 then
		v.drawString(160*FU, ease.inoutsine(mfocus, -39*FU, 7*FU), "Press JUMP to open the menu", V_SNAPTOTOP, "fixed-center")
	end
end)
