--shorter (more unoptimized) and comphrehendable version

--we dont care about mp support lol!!!!
--also projector thinker goes here too
local musictime = 0
local chujinone = false
local chujins = 0 --you thought the (purple) chujins worked (red) alone?
local sectorlist = {}
local vfoflist = {}
local cfoflist = {}

local MUSIC_START = 0
local MUSIC_END = 144008

local ProjectorWhite = 1
local WHITETORED = {
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
	{200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200},
	{32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32}
}
local WHITETOBLU = {
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{144,144,144,144,144,144,144,144,144,144,144,144,144,144,144,144},
	{145,145,145,145,145,145,145,145,145,145,145,145,145,145,145,145},
	{146,146,146,146,146,146,146,146,146,146,146,146,146,146,146,146},
}

skincolors[SKINCOLOR_PROJECTOR] = {
    name = "Projector",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    invcolor = SKINCOLOR_JET,
    invshade = 4,
    chatcolor = V_GRAYMAP,
    accessible = false
}

/*
There is four args in each table.
First and second args in tables is time (in miliseconds) window.
Third is string defining color.
Fourth is boolean defining collision of certain FOFs
*/

local MusicTiming = {
	{MUSIC_START, 3400, "non", false},
	{3400, 7200, "red", false},
	{7200, 11900, "non", true},
	{11900, 14100, "blu", true},
	{14100, 18750, "non", true},
	{18750, 21000, "blu", true},
	{21000, 25750, "non", false},
	{25750, 27600, "red", false},
	{27600, 32400, "non", false},
	{32400, 34500, "red", false},
	{34500, 39450, "non", true},
	{39450, 41200, "blu", true},
	{41200, 46150, "non", true},
	{46150, 48100, "blu", true},
	{48100, 53100, "non", false},
	{53100, 55000, "red", false},
	{55000, 58250, "non", false},
	{58250, 61700, "red", false},
	{61700, 66800, "non", true},
	{66800, 68900, "blu", true},
	{68900, 73680, "non", true},
	{73680, 75800, "blu", true},
	{75800, 85700, "non", false},
	{85700, 89400, "red", false},
	{89400, 94250, "non", true},
	{94250, 96050, "blu", true},
	{96050, 101100, "non", true},
	{101100, 103000, "blu", true},
	{103000, 108000, "non", true},
	{108000, 109880, "blu", true},
	{109880, 114700, "non", true},
	{114700, 116900, "blu", true},
	{116900, 121660, "non", false},
	{121660, 123650, "red", false},
	{123650, 126800, "non", false},
	{126800, 130500, "red", false},
	{130500, 135250, "non", true},
	{135250, 137340, "blu", true},
	{137340, 140500, "non", true},
	{140500, 143500, "blu", true},
	{143500, MUSIC_END, "non", false},
}

local function IsRAZ2()
	if gamemap ~= 642 then return false end
	if mapheaderinfo[gamemap].lvlttl ~= "Rocket Arena" then return false end
	if mapheaderinfo[gamemap].actnum ~= 2 then return false end
	if mapheaderinfo[gamemap].musname ~= "RAZ2" then return false end
	return true
end

local function IsRAZ2FLR(pic)
	if pic == "RAZ2FLR7" then return true end
	if pic == "RAZ2FLR0" then return true end
	if pic == "RAZ2FLR3" then return true end
	return false
end

--top hacks stjr doesn't want you to know
local function IsFOFCollision(FOF)
	if FOF.toppic == "RAZFLR" then return true end
	return false
end

--top hacks stjr doesn't want you to know 2
local function IsFOFVisual(FOF)
	if FOF.toppic == "REDFLR" then return true end
	return false
end

--instead of iterating through the table per each sector do it once and then
--return a table
local function CurrentTime()
	for key, tw in ipairs(MusicTiming) do
		if musictime >= tw[1] and musictime <= tw[2] then
			return tw
		end
	end
end

local function Animate(thing, fofvisual, timewindow)
	if not IsRAZ2() then return end
	local usertype = userdataType(thing)
	local tw1 = timewindow[1]
	local tw2 = timewindow[2]
	local color = timewindow[3]
	local collidable = timewindow[4]
	if musictime >= tw1 and musictime <= tw2 then
		if usertype == "sector_t" then
			if color == "red" then
				if IsRAZ2FLR(thing.floorpic) then thing.floorpic = "RAZ2FLR3"
				elseif IsRAZ2FLR(thing.ceilingpic) then thing.ceilingpic = "RAZ2FLR3" end
			elseif color == "blu" then
				if IsRAZ2FLR(thing.floorpic) then thing.floorpic = "RAZ2FLR7"
				elseif IsRAZ2FLR(thing.ceilingpic) then thing.ceilingpic = "RAZ2FLR7" end
			else
				if IsRAZ2FLR(thing.floorpic) then thing.floorpic = "RAZ2FLR0"
				elseif IsRAZ2FLR(thing.ceilingpic) then thing.ceilingpic = "RAZ2FLR0" end
			end
		elseif usertype == "ffloor_t" then
			if fofvisual then
				if color == "red" then
					if thing.alpha <= 1
						thing.alpha = 177
					else
						thing.alpha = $ - 13
					end
				elseif color == "blu" then
					if thing.alpha >= 177
						thing.alpha = 1
					else
						thing.alpha = $ + 13
					end
				elseif collidable then
					thing.alpha = 177
				else
					thing.alpha = 1
				end
			else
				if collidable then
					thing.flags = 67
				else
					thing.flags = 65
				end
			end
		end
	end
end

--redefault vars on map change
addHook("MapChange", function(mapnum)
	chujinone = false
	chujins = 0
	musictime = 0
	sectorlist = {}
	vfoflist = {}
	cfoflist = {}
end)

addHook("MapLoad", function(mapnum)
	if not IsRAZ2() then return end
	for player in players.iterate do
		if player.chujinone == true then chujins = $ + 1 end --yes, the (purple) chujins worked (red) alone.
		if chujins > 1 then
			player.chujinone = false
			chujins = $ - 1
		end
	end
	for sector in sectors.iterate do
		if IsRAZ2FLR(sector.floorpic) or IsRAZ2FLR(sector.ceilingpic) then
			table.insert(sectorlist, sector)
		end
		for rover in sector.ffloors() do
			if IsFOFVisual(rover) then
				table.insert(vfoflist, rover)
			elseif IsFOFCollision(rover) then
				table.insert(cfoflist, rover)
			end
		end
	end
	if netgame then
		print("this map isnt network safe! (i think)")
	end
end)

addHook("PreThinkFrame", function()
	if not IsRAZ2() then return end
	for player in players.iterate do
		if player.bot then continue end --captcha
		if chujinone then
			if player.chujinone == true --grab the music position of random player
				if S_MusicName(player) ~= "RAZ2" then
					musictime = $ + 28
					if musictime > MUSIC_END then musictime = MUSIC_START end
				else
					musictime = S_GetMusicPosition()
				end
			elseif S_MusicName(player) == "RAZ2" and (S_GetMusicPosition() < musictime-1000
			or S_GetMusicPosition() > musictime+1000)
				S_SetMusicPosition(musictime) --might cause issues but basically it tries to sync the music for everyone
			end
		else
			player.chujinone = true
			chujinone = true
		end
	end
end)

addHook("ThinkFrame", function()
	if not IsRAZ2() then return end
	local timewindow = CurrentTime()
	for key, sector in pairs(sectorlist) do
		Animate(sector, false, timewindow)
	end
	for key, rover in pairs(vfoflist) do
		Animate(rover, true, timewindow)
	end
	for key, rover in pairs(cfoflist) do
		Animate(rover, false, timewindow)
	end
	ProjectorWhite = $+1
	if ProjectorWhite > 15 then ProjectorWhite = 1 end
	if timewindow[3] == "red" then
		skincolors[SKINCOLOR_PROJECTOR].ramp = WHITETORED[ProjectorWhite/4+1]
	elseif timewindow[3] == "blu" then
		skincolors[SKINCOLOR_PROJECTOR].ramp = WHITETOBLU[ProjectorWhite/4+1]
	elseif timewindow[4] then
		skincolors[SKINCOLOR_PROJECTOR].ramp = WHITETORED[4]
	else
		skincolors[SKINCOLOR_PROJECTOR].ramp = WHITETOBLU[4]
	end
end)

--projector
states[S_PROJECTOR] = {SPR_LAMP, A, -1, nil, 0, 0, S_PROJECTOR}

mobjinfo[MT_PROJECTOR] = {
	--$Title Projector
	--$Sprite LAMPA2A8
	--$Category PHLIGHT/Decor
	doomednum = 2307,
	spawnstate = S_PROJECTOR,
	spawnhealth = 999,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_SCENERY
}

addHook("MobjThinker", function(mobj)
	if mobj.alreadyspawned then return end
	for i = 1,5 do
		local light = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
		light.target = mobj
		light.angle = mobj.angle
		local x = mobj.x + P_ReturnThrustX(mobj, mobj.angle, 24*i*FU)
		local y = mobj.y + P_ReturnThrustY(mobj, mobj.angle, 24*i*FU)
		local z = mobj.z + 32*i*FU
		light.scale = FU+((i-1)*(FU/5))
		P_SetOrigin(light, x, y, z)
		light.color = SKINCOLOR_PROJECTOR
		light.blendmode = AST_TRANSLUCENT
		light.OwnedByProjector = true
	end
	mobj.color = SKINCOLOR_PROJECTOR
	mobj.alreadyspawned = true
end, MT_PROJECTOR)

addHook("MobjThinker", function(light)
	if light.OwnedByProjector == true then
		light.renderflags = $|RF_FULLBRIGHT
		return true
	end
end, MT_THOK)