--this is spice runners dlc and you gotta pla

--just adding custom pizzaface skin :3
local SpiceRunning = false
freeslot("SPR_KATA", "S_KATANA")
states[S_KATANA] = {SPR_KATA, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_KATANA}
--stuff for One Minute Left
local AnimationTime = 0
local oneleftpos = 0
local minutescale = 0
local byebye = 0

addHook("PreThinkFrame", function()
	if PTSR == nil then return end
	if not PTSR.IsPTSR() then return end
	if not (consoleplayer and consoleplayer.valid) end
	if SpiceRunning == false then
		table.insert(PTSR.PFMaskData, {
		name = "Katana",
		state = S_KATANA,
		scale = FU*4,
		trails = {SKINCOLOR_RED, SKINCOLOR_BLUE},
		sound = sfx_slash,
		emoji = ":knife:",
		momentum = true,
		aiselectable = true,
		tagcolor = SKINCOLOR_RED
		})
		SpiceRunning = true
	end
	if (not multiplayer and gamestate == GS_LEVEL) then return end
	if PTSR.timeleft == 63*TICRATE then
		S_FadeMusic(0, 2000)
	end
	if PTSR.timeleft <= 61*TICRATE and PTSR.timeleft > 0
	and S_MusicName(consoleplayer) ~= "huryup" then
		local position = (60*1000)-((PTSR.timeleft-TICRATE)*1000)/TICRATE
		S_ChangeMusic("HURYUP", false, consoleplayer, 0, position)
	end
	if PTSR.timeleft == 60*TICRATE then
		AnimationTime = 1
	end
end)

addHook("MusicChange", function(old, new, idk, idk1, idk2, idk3, idk4)
	if PTSR == nil then return end
	if not PTSR.IsPTSR() then return end
	if old ~= PTSR.ReturnPizzaTimeMusic() and new == "HURYUP" then return true end
	if old == "HURYUP" and new == PTSR.ReturnPizzaTimeMusic() then return true end
end)

hud.add(function(v, p)
	if not (p and p.valid) then return end
	if PTSR == nil then return end
	if not PTSR.IsPTSR() then return end
	if (not multiplayer and gamestate == GS_LEVEL) then return end
	if AnimationTime == 0 then return
	elseif AnimationTime > 9*TICRATE/2 then
		AnimationTime = 0
		return
	end
	if AnimationTime == 1 then
		oneleftpos = 0
		minutescale = 0
		byebye = 0
	end
	
	local onelefttime = min(FU, AnimationTime*(FU/25))
	oneleftpos = ease.outexpo(onelefttime, 0, 160*FU)
	if AnimationTime >= 1*TICRATE then
		local minutetime = min(FU, (AnimationTime-1*TICRATE)*(FU/35))
		minutescale = ease.inoutexpo(minutetime, 0, FU)
	end
	if AnimationTime > 3*TICRATE then
		local byebyetime = min(FU, (AnimationTime-5*TICRATE/2)*(FU/40))
		byebye = ease.inexpo(byebyetime, 0, 360*FU)
	end
	
	v.drawStretched(160*FU-minutescale*55+byebye, 100*FU-(31*FU)/3, minutescale/3,
	FU/3, v.cachePatch("SR_MINUTE"), 0, v.getColormap(TC_DEFAULT, p.realmo.color))
	
	v.drawScaled(94*FU-(minutescale*110)/2+byebye, -60*FU+oneleftpos-(31*FU)/3,
	FU/3, v.cachePatch("SR_ONE"), 0, v.getColormap(TC_DEFAULT, p.realmo.color))
	
	v.drawScaled(164*FU+(minutescale*110)/2+byebye, 260*FU-oneleftpos-(31*FU)/3,
	FU/3, v.cachePatch("SR_LEFT"), 0, v.getColormap(TC_DEFAULT, p.realmo.color))
	
	AnimationTime = $+1
end)



