states[S_JP_FLY] = {SPR_PKOK, A, -1, nil, 0, 0, S_JP_FLY}
states[S_JP_OUCH] = {SPR_PKAA, A, 32, nil, 0, 0, S_JP_FLY}

mobjinfo[MT_JETPACK] = {
	--$Title Jetpack Civillian
	--$Sprite PKOKA0
	--$Category PHLIGHT
	doomednum = 2303,
	spawnstate = S_JP_FLY,
	spawnhealth = 999,
	reactiontime = 0,
	painchance = 0,
	speed = 4,
	radius = 25*FRACUNIT,
	height = 71*FRACUNIT,
	flags = MF_PAIN|MF_NOGRAVITY
}

addHook("MobjThinker", function(jet)
	jet.angle = $ + ANG2/3
	P_InstaThrust(jet, jet.angle, 2*FRACUNIT)
end, MT_JETPACK)

addHook("ShouldDamage", function(pmo, jet, nobody, dmg, type)
	if pmo == nil return end
	if jet == nil return end
	if jet.type == MT_JETPACK then
		if pmo.momz < 0 then
			pmo.momz = abs(pmo.momz)
			S_StartSound(jet, sfx_ouch)
			jet.state = S_JP_OUCH
		end
		return false
	end
end, MT_PLAYER)