states[S_AOESLASH] = {SPR_SLSH, A, -1, nil, 0, 0, S_AOESLASH}

mobjinfo[MT_AOESLASH] = {
	--$Title Katana Phinisher
	--$Sprite SLSHA0
	--$Category PHLIGHT/Missiles (why would u need a missile spawner lol)
	doomednum = -1,
	spawnstate = S_AOESLASH,
	dispoffset = 1,
	spawnhealth = 999,
	reactiontime = 0,
	painchance = 0,
	speed = 0,
	radius = 190*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_PAIN|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mobj)
	mobj.lifetime = 30
end, MT_AOESLASH)

addHook("MobjThinker", function(mobj)
	mobj.lifetime = $ - 1
	if mobj.lifetime <= 0 then
		P_RemoveMobj(mobj)
	elseif mobj.lifetime <= 2 then
		mobj.frame = A|FF_TRANS90
	elseif mobj.lifetime <= 4 then
		mobj.frame = A|FF_TRANS80
	elseif mobj.lifetime <= 6 then
		mobj.frame = A|FF_TRANS70
	elseif mobj.lifetime <= 8 then
		mobj.frame = A|FF_TRANS60
		mobj.flags = MF_NOGRAVITY
	elseif mobj.lifetime <= 10 then
		mobj.frame = A|FF_TRANS50
	elseif mobj.lifetime <= 12 then
		mobj.frame = A|FF_TRANS40
	elseif mobj.lifetime <= 14 then
		mobj.frame = A|FF_TRANS30
	elseif mobj.lifetime <= 16 then
		mobj.frame = A|FF_TRANS20
	elseif mobj.lifetime <= 18 then
		mobj.frame = A|FF_TRANS10
	end
end, MT_AOESLASH)