states[S_SPY_FLY] = {SPR_SPGR, A, -1, nil, 0, 0, S_SPY_FLY}
states[S_SPY_CHASE] = {SPR_SPGR, A, -1, nil, 0, 0, S_SPY_CHASE}

mobjinfo[MT_SPYGRAFT] = {
	--$Title Spygraft
	--$Sprite SPGRA0
	--$Category PHLIGHT
	doomednum = 2304,
	spawnstate = S_SPY_FLY,
	spawnhealth = 1,
	reactiontime = 0,
	painchance = 0,
	deathstate = S_XPLD1,
	deathsound = sfx_pop,
	speed = 7*FU,
	radius = 25*FRACUNIT,
	height = 71*FRACUNIT,
	flags = MF_ENEMY|MF_SPECIAL|MF_SHOOTABLE|MF_NOGRAVITY
}

addHook("MobjThinker", function(jet)
	if jet == nil then return end
	if jet.valid == nil then return end
	if jet.health == 0 then return end
	if jet.state == S_SPY_FLY
		jet.momz = 0
		jet.angle = $ + ANG2/3
		P_InstaThrust(jet, jet.angle, 2*FRACUNIT)
		if P_LookForPlayers(jet, 5760*FU, false, false) then jet.state = S_SPY_CHASE end
	else
		if not P_LookForPlayers(jet, 5760*FU, false, false) then
			jet.state = S_SPY_FLY
			return
		end
		if jet.z > jet.target.z then jet.momz = $-FU end
		if jet.z < jet.target.z then jet.momz = $+FU end
		if jet.momz > 32*FU then jet.momz = 32*FU end
		if jet.momz < -32*FU then jet.momz = -32*FU end
		P_HomingAttack(jet, jet.target)
	end
end, MT_SPYGRAFT)